=== debian/changelog ===
scummvm (2026.1.0+dfsg-1build1) resolute; urgency=medium

  * Rebuild against libvpx12.

 -- Mate Kukri <mate.kukri@canonical.com>  Wed, 25 Feb 2026 12:51:55 +0000

scummvm (2026.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop “Rules-Requires-Root: no” since it’s now the default.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 31 Jan 2026 22:46:11 +0100
